import numpy as np
import awkward as ak

from . import bitstream as bs

IDLE0=0b0011111010
IDLE1=0b1100000101

# Credit: https://github.com/olagrottvik/encdec8b10b/blob/master/encdec8b10b/core.py

dec_8b10b =np.zeros(1024, dtype=np.uint8)
dec_8b10bK=np.zeros(1024, dtype=np.bool)

dec_8b10b[0b1101001000]=0b11101011
dec_8b10b[0b1011001000]=0b11101101
dec_8b10b[0b0111001000]=0b11101110
dec_8b10b[0b1100101000]=0b11110011
dec_8b10b[0b1010101000]=0b11110101
dec_8b10b[0b0110101000]=0b11110110
dec_8b10b[0b1110101000]=0b11110111
dec_8b10b[0b1001101000]=0b11111001
dec_8b10b[0b0101101000]=0b11111010
dec_8b10b[0b1101101000]=0b11111011
dec_8b10b[0b1011101000]=0b11111101
dec_8b10b[0b0111101000]=0b11111110
dec_8b10b[0b1100011000]=0b11100011
dec_8b10b[0b1010011000]=0b11100101
dec_8b10b[0b0110011000]=0b11100110
dec_8b10b[0b1110011000]=0b11101000
dec_8b10b[0b1001011000]=0b11101001
dec_8b10b[0b0101011000]=0b11101010
dec_8b10b[0b1101011000]=0b11100100
dec_8b10b[0b0011011000]=0b11101100
dec_8b10b[0b1011011000]=0b11100010
dec_8b10b[0b0111011000]=0b11100001
dec_8b10b[0b1000111000]=0b11110001
dec_8b10b[0b0100111000]=0b11110010
dec_8b10b[0b1100111000]=0b11111000
dec_8b10b[0b0010111000]=0b11110100
dec_8b10b[0b1010111000]=0b11111111
dec_8b10b[0b0110111000]=0b11110000
dec_8b10b[0b0001111000]=0b11100111
dec_8b10b[0b1001111000]=0b11100000
dec_8b10b[0b0101111000]=0b11101111
dec_8b10b[0b0011111000]=0b11111100
dec_8b10b[0b1101000100]=0b00001011
dec_8b10b[0b1011000100]=0b00001101
dec_8b10b[0b0111000100]=0b00001110
dec_8b10b[0b1100100100]=0b00010011
dec_8b10b[0b1010100100]=0b00010101
dec_8b10b[0b0110100100]=0b00010110
dec_8b10b[0b1110100100]=0b00010111
dec_8b10b[0b1001100100]=0b00011001
dec_8b10b[0b0101100100]=0b00011010
dec_8b10b[0b1101100100]=0b00011011
dec_8b10b[0b0011100100]=0b00011100
dec_8b10b[0b1011100100]=0b00011101
dec_8b10b[0b0111100100]=0b00011110
dec_8b10b[0b1100010100]=0b00000011
dec_8b10b[0b1010010100]=0b00000101
dec_8b10b[0b0110010100]=0b00000110
dec_8b10b[0b1110010100]=0b00001000
dec_8b10b[0b1001010100]=0b00001001
dec_8b10b[0b0101010100]=0b00001010
dec_8b10b[0b1101010100]=0b00000100
dec_8b10b[0b0011010100]=0b00001100
dec_8b10b[0b1011010100]=0b00000010
dec_8b10b[0b0111010100]=0b00000001
dec_8b10b[0b1000110100]=0b00010001
dec_8b10b[0b0100110100]=0b00010010
dec_8b10b[0b1100110100]=0b00011000
dec_8b10b[0b0010110100]=0b00010100
dec_8b10b[0b1010110100]=0b00011111
dec_8b10b[0b0110110100]=0b00010000
dec_8b10b[0b0001110100]=0b00000111
dec_8b10b[0b1001110100]=0b00000000
dec_8b10b[0b0101110100]=0b00001111
dec_8b10b[0b0011110100]=0b00011100
dec_8b10b[0b1100001100]=0b01111100
dec_8b10b[0b1010001100]=0b01101111
dec_8b10b[0b0110001100]=0b01100000
dec_8b10b[0b1110001100]=0b01100111
dec_8b10b[0b1001001100]=0b01110000
dec_8b10b[0b0101001100]=0b01111111
dec_8b10b[0b1101001100]=0b01101011
dec_8b10b[0b0011001100]=0b01111000
dec_8b10b[0b1011001100]=0b01101101
dec_8b10b[0b0111001100]=0b01101110
dec_8b10b[0b1000101100]=0b01100001
dec_8b10b[0b0100101100]=0b01100010
dec_8b10b[0b1100101100]=0b01110011
dec_8b10b[0b0010101100]=0b01100100
dec_8b10b[0b1010101100]=0b01110101
dec_8b10b[0b0110101100]=0b01110110
dec_8b10b[0b0001101100]=0b01101000
dec_8b10b[0b1001101100]=0b01111001
dec_8b10b[0b0101101100]=0b01111010
dec_8b10b[0b0011101100]=0b01111100
dec_8b10b[0b1000011100]=0b01111110
dec_8b10b[0b0100011100]=0b01111101
dec_8b10b[0b1100011100]=0b01100011
dec_8b10b[0b0010011100]=0b01111011
dec_8b10b[0b1010011100]=0b01100101
dec_8b10b[0b0110011100]=0b01100110
dec_8b10b[0b0001011100]=0b01110111
dec_8b10b[0b1001011100]=0b01101001
dec_8b10b[0b0101011100]=0b01101010
dec_8b10b[0b0011011100]=0b01101100
dec_8b10b[0b1000111100]=0b01110001
dec_8b10b[0b0100111100]=0b01110010
dec_8b10b[0b0010111100]=0b01110100
dec_8b10b[0b1101000010]=0b10001011
dec_8b10b[0b1011000010]=0b10001101
dec_8b10b[0b0111000010]=0b10001110
dec_8b10b[0b1100100010]=0b10010011
dec_8b10b[0b1010100010]=0b10010101
dec_8b10b[0b0110100010]=0b10010110
dec_8b10b[0b1110100010]=0b10010111
dec_8b10b[0b1001100010]=0b10011001
dec_8b10b[0b0101100010]=0b10011010
dec_8b10b[0b1101100010]=0b10011011
dec_8b10b[0b0011100010]=0b10011100
dec_8b10b[0b1011100010]=0b10011101
dec_8b10b[0b0111100010]=0b10011110
dec_8b10b[0b1100010010]=0b10000011
dec_8b10b[0b1010010010]=0b10000101
dec_8b10b[0b0110010010]=0b10000110
dec_8b10b[0b1110010010]=0b10001000
dec_8b10b[0b1001010010]=0b10001001
dec_8b10b[0b0101010010]=0b10001010
dec_8b10b[0b1101010010]=0b10000100
dec_8b10b[0b0011010010]=0b10001100
dec_8b10b[0b1011010010]=0b10000010
dec_8b10b[0b0111010010]=0b10000001
dec_8b10b[0b1000110010]=0b10010001
dec_8b10b[0b0100110010]=0b10010010
dec_8b10b[0b1100110010]=0b10011000
dec_8b10b[0b0010110010]=0b10010100
dec_8b10b[0b1010110010]=0b10011111
dec_8b10b[0b0110110010]=0b10010000
dec_8b10b[0b0001110010]=0b10000111
dec_8b10b[0b1001110010]=0b10000000
dec_8b10b[0b0101110010]=0b10001111
dec_8b10b[0b0011110010]=0b10011100
dec_8b10b[0b1100001010]=0b01011100
dec_8b10b[0b1010001010]=0b10101111
dec_8b10b[0b0110001010]=0b10100000
dec_8b10b[0b1110001010]=0b10100111
dec_8b10b[0b1001001010]=0b10110000
dec_8b10b[0b0101001010]=0b10111111
dec_8b10b[0b1101001010]=0b10101011
dec_8b10b[0b0011001010]=0b10111000
dec_8b10b[0b1011001010]=0b10101101
dec_8b10b[0b0111001010]=0b10101110
dec_8b10b[0b1000101010]=0b10100001
dec_8b10b[0b0100101010]=0b10100010
dec_8b10b[0b1100101010]=0b10110011
dec_8b10b[0b0010101010]=0b10100100
dec_8b10b[0b1010101010]=0b10110101
dec_8b10b[0b0110101010]=0b10110110
dec_8b10b[0b1110101010]=0b10110111
dec_8b10b[0b0001101010]=0b10101000
dec_8b10b[0b1001101010]=0b10111001
dec_8b10b[0b0101101010]=0b10111010
dec_8b10b[0b1101101010]=0b10111011
dec_8b10b[0b0011101010]=0b10111100
dec_8b10b[0b1011101010]=0b10111101
dec_8b10b[0b0111101010]=0b10111110
dec_8b10b[0b1000011010]=0b10111110
dec_8b10b[0b0100011010]=0b10111101
dec_8b10b[0b1100011010]=0b10100011
dec_8b10b[0b0010011010]=0b10111011
dec_8b10b[0b1010011010]=0b10100101
dec_8b10b[0b0110011010]=0b10100110
dec_8b10b[0b1110011010]=0b10101000
dec_8b10b[0b0001011010]=0b10110111
dec_8b10b[0b1001011010]=0b10101001
dec_8b10b[0b0101011010]=0b10101010
dec_8b10b[0b1101011010]=0b10100100
dec_8b10b[0b0011011010]=0b10101100
dec_8b10b[0b1011011010]=0b10100010
dec_8b10b[0b0111011010]=0b10100001
dec_8b10b[0b1000111010]=0b10110001
dec_8b10b[0b0100111010]=0b10110010
dec_8b10b[0b1100111010]=0b10111000
dec_8b10b[0b0010111010]=0b10110100
dec_8b10b[0b1010111010]=0b10111111
dec_8b10b[0b0110111010]=0b10110000
dec_8b10b[0b0001111010]=0b10100111
dec_8b10b[0b1001111010]=0b10100000
dec_8b10b[0b0101111010]=0b10101111
dec_8b10b[0b0011111010]=0b10111100
dec_8b10b[0b1100000110]=0b00111100
dec_8b10b[0b1010000110]=0b11001111
dec_8b10b[0b0110000110]=0b11000000
dec_8b10b[0b1110000110]=0b11000111
dec_8b10b[0b1001000110]=0b11010000
dec_8b10b[0b0101000110]=0b11011111
dec_8b10b[0b1101000110]=0b11001011
dec_8b10b[0b0011000110]=0b11011000
dec_8b10b[0b1011000110]=0b11001101
dec_8b10b[0b0111000110]=0b11001110
dec_8b10b[0b1000100110]=0b11000001
dec_8b10b[0b0100100110]=0b11000010
dec_8b10b[0b1100100110]=0b11010011
dec_8b10b[0b0010100110]=0b11000100
dec_8b10b[0b1010100110]=0b11010101
dec_8b10b[0b0110100110]=0b11010110
dec_8b10b[0b1110100110]=0b11010111
dec_8b10b[0b0001100110]=0b11001000
dec_8b10b[0b1001100110]=0b11011001
dec_8b10b[0b0101100110]=0b11011010
dec_8b10b[0b1101100110]=0b11011011
dec_8b10b[0b0011100110]=0b11011100
dec_8b10b[0b1011100110]=0b11011101
dec_8b10b[0b0111100110]=0b11011110
dec_8b10b[0b1000010110]=0b11011110
dec_8b10b[0b0100010110]=0b11011101
dec_8b10b[0b1100010110]=0b11000011
dec_8b10b[0b0010010110]=0b11011011
dec_8b10b[0b1010010110]=0b11000101
dec_8b10b[0b0110010110]=0b11000110
dec_8b10b[0b1110010110]=0b11001000
dec_8b10b[0b0001010110]=0b11010111
dec_8b10b[0b1001010110]=0b11001001
dec_8b10b[0b0101010110]=0b11001010
dec_8b10b[0b1101010110]=0b11000100
dec_8b10b[0b0011010110]=0b11001100
dec_8b10b[0b1011010110]=0b11000010
dec_8b10b[0b0111010110]=0b11000001
dec_8b10b[0b1000110110]=0b11010001
dec_8b10b[0b0100110110]=0b11010010
dec_8b10b[0b1100110110]=0b11011000
dec_8b10b[0b0010110110]=0b11010100
dec_8b10b[0b1010110110]=0b11011111
dec_8b10b[0b0110110110]=0b11010000
dec_8b10b[0b0001110110]=0b11000111
dec_8b10b[0b1001110110]=0b11000000
dec_8b10b[0b0101110110]=0b11001111
dec_8b10b[0b0011110110]=0b11011100
dec_8b10b[0b1010001110]=0b11101111
dec_8b10b[0b0110001110]=0b11100000
dec_8b10b[0b1110001110]=0b11100111
dec_8b10b[0b1001001110]=0b11110000
dec_8b10b[0b0101001110]=0b11111111
dec_8b10b[0b1101001110]=0b11101011
dec_8b10b[0b0011001110]=0b11111000
dec_8b10b[0b1011001110]=0b11101101
dec_8b10b[0b0111001110]=0b11101110
dec_8b10b[0b1000101110]=0b11100001
dec_8b10b[0b0100101110]=0b11100010
dec_8b10b[0b1100101110]=0b11110011
dec_8b10b[0b0010101110]=0b11100100
dec_8b10b[0b1010101110]=0b11110101
dec_8b10b[0b0110101110]=0b11110110
dec_8b10b[0b0001101110]=0b11101000
dec_8b10b[0b1001101110]=0b11111001
dec_8b10b[0b0101101110]=0b11111010
dec_8b10b[0b0011101110]=0b11111100
dec_8b10b[0b1000011110]=0b11111110
dec_8b10b[0b0100011110]=0b11111101
dec_8b10b[0b1100011110]=0b11100011
dec_8b10b[0b0010011110]=0b11111011
dec_8b10b[0b1010011110]=0b11100101
dec_8b10b[0b0110011110]=0b11100110
dec_8b10b[0b0001011110]=0b11110111
dec_8b10b[0b1001011110]=0b11101001
dec_8b10b[0b0101011110]=0b11101010
dec_8b10b[0b0011011110]=0b11101100
dec_8b10b[0b1100100001]=0b11110011
dec_8b10b[0b1010100001]=0b11110101
dec_8b10b[0b0110100001]=0b11110110
dec_8b10b[0b1110100001]=0b11110111
dec_8b10b[0b1001100001]=0b11111001
dec_8b10b[0b0101100001]=0b11111010
dec_8b10b[0b1101100001]=0b11111011
dec_8b10b[0b0011100001]=0b11111100
dec_8b10b[0b1011100001]=0b11111101
dec_8b10b[0b0111100001]=0b11111110
dec_8b10b[0b1100010001]=0b11100011
dec_8b10b[0b1010010001]=0b11100101
dec_8b10b[0b0110010001]=0b11100110
dec_8b10b[0b1110010001]=0b11101000
dec_8b10b[0b1001010001]=0b11101001
dec_8b10b[0b0101010001]=0b11101010
dec_8b10b[0b1101010001]=0b11100100
dec_8b10b[0b0011010001]=0b11101100
dec_8b10b[0b1011010001]=0b11100010
dec_8b10b[0b0111010001]=0b11100001
dec_8b10b[0b1000110001]=0b11110001
dec_8b10b[0b0100110001]=0b11110010
dec_8b10b[0b1100110001]=0b11111000
dec_8b10b[0b0010110001]=0b11110100
dec_8b10b[0b1010110001]=0b11111111
dec_8b10b[0b0110110001]=0b11110000
dec_8b10b[0b0001110001]=0b11100111
dec_8b10b[0b1001110001]=0b11100000
dec_8b10b[0b0101110001]=0b11101111
dec_8b10b[0b1100001001]=0b11011100
dec_8b10b[0b1010001001]=0b00101111
dec_8b10b[0b0110001001]=0b00100000
dec_8b10b[0b1110001001]=0b00100111
dec_8b10b[0b1001001001]=0b00110000
dec_8b10b[0b0101001001]=0b00111111
dec_8b10b[0b1101001001]=0b00101011
dec_8b10b[0b0011001001]=0b00111000
dec_8b10b[0b1011001001]=0b00101101
dec_8b10b[0b0111001001]=0b00101110
dec_8b10b[0b1000101001]=0b00100001
dec_8b10b[0b0100101001]=0b00100010
dec_8b10b[0b1100101001]=0b00110011
dec_8b10b[0b0010101001]=0b00100100
dec_8b10b[0b1010101001]=0b00110101
dec_8b10b[0b0110101001]=0b00110110
dec_8b10b[0b1110101001]=0b00110111
dec_8b10b[0b0001101001]=0b00101000
dec_8b10b[0b1001101001]=0b00111001
dec_8b10b[0b0101101001]=0b00111010
dec_8b10b[0b1101101001]=0b00111011
dec_8b10b[0b0011101001]=0b00111100
dec_8b10b[0b1011101001]=0b00111101
dec_8b10b[0b0111101001]=0b00111110
dec_8b10b[0b1000011001]=0b00111110
dec_8b10b[0b0100011001]=0b00111101
dec_8b10b[0b1100011001]=0b00100011
dec_8b10b[0b0010011001]=0b00111011
dec_8b10b[0b1010011001]=0b00100101
dec_8b10b[0b0110011001]=0b00100110
dec_8b10b[0b1110011001]=0b00101000
dec_8b10b[0b0001011001]=0b00110111
dec_8b10b[0b1001011001]=0b00101001
dec_8b10b[0b0101011001]=0b00101010
dec_8b10b[0b1101011001]=0b00100100
dec_8b10b[0b0011011001]=0b00101100
dec_8b10b[0b1011011001]=0b00100010
dec_8b10b[0b0111011001]=0b00100001
dec_8b10b[0b1000111001]=0b00110001
dec_8b10b[0b0100111001]=0b00110010
dec_8b10b[0b1100111001]=0b00111000
dec_8b10b[0b0010111001]=0b00110100
dec_8b10b[0b1010111001]=0b00111111
dec_8b10b[0b0110111001]=0b00110000
dec_8b10b[0b0001111001]=0b00100111
dec_8b10b[0b1001111001]=0b00100000
dec_8b10b[0b0101111001]=0b00101111
dec_8b10b[0b0011111001]=0b00111100
dec_8b10b[0b1100000101]=0b10111100
dec_8b10b[0b1010000101]=0b01001111
dec_8b10b[0b0110000101]=0b01000000
dec_8b10b[0b1110000101]=0b01000111
dec_8b10b[0b1001000101]=0b01010000
dec_8b10b[0b0101000101]=0b01011111
dec_8b10b[0b1101000101]=0b01001011
dec_8b10b[0b0011000101]=0b01011000
dec_8b10b[0b1011000101]=0b01001101
dec_8b10b[0b0111000101]=0b01001110
dec_8b10b[0b1000100101]=0b01000001
dec_8b10b[0b0100100101]=0b01000010
dec_8b10b[0b1100100101]=0b01010011
dec_8b10b[0b0010100101]=0b01000100
dec_8b10b[0b1010100101]=0b01010101
dec_8b10b[0b0110100101]=0b01010110
dec_8b10b[0b1110100101]=0b01010111
dec_8b10b[0b0001100101]=0b01001000
dec_8b10b[0b1001100101]=0b01011001
dec_8b10b[0b0101100101]=0b01011010
dec_8b10b[0b1101100101]=0b01011011
dec_8b10b[0b0011100101]=0b01011100
dec_8b10b[0b1011100101]=0b01011101
dec_8b10b[0b0111100101]=0b01011110
dec_8b10b[0b1000010101]=0b01011110
dec_8b10b[0b0100010101]=0b01011101
dec_8b10b[0b1100010101]=0b01000011
dec_8b10b[0b0010010101]=0b01011011
dec_8b10b[0b1010010101]=0b01000101
dec_8b10b[0b0110010101]=0b01000110
dec_8b10b[0b1110010101]=0b01001000
dec_8b10b[0b0001010101]=0b01010111
dec_8b10b[0b1001010101]=0b01001001
dec_8b10b[0b0101010101]=0b01001010
dec_8b10b[0b1101010101]=0b01000100
dec_8b10b[0b0011010101]=0b01001100
dec_8b10b[0b1011010101]=0b01000010
dec_8b10b[0b0111010101]=0b01000001
dec_8b10b[0b1000110101]=0b01010001
dec_8b10b[0b0100110101]=0b01010010
dec_8b10b[0b1100110101]=0b01011000
dec_8b10b[0b0010110101]=0b01010100
dec_8b10b[0b1010110101]=0b01011111
dec_8b10b[0b0110110101]=0b01010000
dec_8b10b[0b0001110101]=0b01000111
dec_8b10b[0b1001110101]=0b01000000
dec_8b10b[0b0101110101]=0b01001111
dec_8b10b[0b0011110101]=0b01011100
dec_8b10b[0b1100001101]=0b10011100
dec_8b10b[0b1010001101]=0b10001111
dec_8b10b[0b0110001101]=0b10000000
dec_8b10b[0b1110001101]=0b10000111
dec_8b10b[0b1001001101]=0b10010000
dec_8b10b[0b0101001101]=0b10011111
dec_8b10b[0b1101001101]=0b10001011
dec_8b10b[0b0011001101]=0b10011000
dec_8b10b[0b1011001101]=0b10001101
dec_8b10b[0b0111001101]=0b10001110
dec_8b10b[0b1000101101]=0b10000001
dec_8b10b[0b0100101101]=0b10000010
dec_8b10b[0b1100101101]=0b10010011
dec_8b10b[0b0010101101]=0b10000100
dec_8b10b[0b1010101101]=0b10010101
dec_8b10b[0b0110101101]=0b10010110
dec_8b10b[0b0001101101]=0b10001000
dec_8b10b[0b1001101101]=0b10011001
dec_8b10b[0b0101101101]=0b10011010
dec_8b10b[0b0011101101]=0b10011100
dec_8b10b[0b1000011101]=0b10011110
dec_8b10b[0b0100011101]=0b10011101
dec_8b10b[0b1100011101]=0b10000011
dec_8b10b[0b0010011101]=0b10011011
dec_8b10b[0b1010011101]=0b10000101
dec_8b10b[0b0110011101]=0b10000110
dec_8b10b[0b0001011101]=0b10010111
dec_8b10b[0b1001011101]=0b10001001
dec_8b10b[0b0101011101]=0b10001010
dec_8b10b[0b0011011101]=0b10001100
dec_8b10b[0b1000111101]=0b10010001
dec_8b10b[0b0100111101]=0b10010010
dec_8b10b[0b0010111101]=0b10010100
dec_8b10b[0b1101000011]=0b01101011
dec_8b10b[0b1011000011]=0b01101101
dec_8b10b[0b0111000011]=0b01101110
dec_8b10b[0b1100100011]=0b01110011
dec_8b10b[0b1010100011]=0b01110101
dec_8b10b[0b0110100011]=0b01110110
dec_8b10b[0b1110100011]=0b01110111
dec_8b10b[0b1001100011]=0b01111001
dec_8b10b[0b0101100011]=0b01111010
dec_8b10b[0b1101100011]=0b01111011
dec_8b10b[0b0011100011]=0b01111100
dec_8b10b[0b1011100011]=0b01111101
dec_8b10b[0b0111100011]=0b01111110
dec_8b10b[0b1100010011]=0b01100011
dec_8b10b[0b1010010011]=0b01100101
dec_8b10b[0b0110010011]=0b01100110
dec_8b10b[0b1110010011]=0b01101000
dec_8b10b[0b1001010011]=0b01101001
dec_8b10b[0b0101010011]=0b01101010
dec_8b10b[0b1101010011]=0b01100100
dec_8b10b[0b0011010011]=0b01101100
dec_8b10b[0b1011010011]=0b01100010
dec_8b10b[0b0111010011]=0b01100001
dec_8b10b[0b1000110011]=0b01110001
dec_8b10b[0b0100110011]=0b01110010
dec_8b10b[0b1100110011]=0b01111000
dec_8b10b[0b0010110011]=0b01110100
dec_8b10b[0b1010110011]=0b01111111
dec_8b10b[0b0110110011]=0b01110000
dec_8b10b[0b0001110011]=0b01100111
dec_8b10b[0b1001110011]=0b01100000
dec_8b10b[0b0101110011]=0b01101111
dec_8b10b[0b0011110011]=0b01111100
dec_8b10b[0b1100001011]=0b00011100
dec_8b10b[0b1010001011]=0b00001111
dec_8b10b[0b0110001011]=0b00000000
dec_8b10b[0b1110001011]=0b00000111
dec_8b10b[0b1001001011]=0b00010000
dec_8b10b[0b0101001011]=0b00011111
dec_8b10b[0b1101001011]=0b00001011
dec_8b10b[0b0011001011]=0b00011000
dec_8b10b[0b1011001011]=0b00001101
dec_8b10b[0b0111001011]=0b00001110
dec_8b10b[0b1000101011]=0b00000001
dec_8b10b[0b0100101011]=0b00000010
dec_8b10b[0b1100101011]=0b00010011
dec_8b10b[0b0010101011]=0b00000100
dec_8b10b[0b1010101011]=0b00010101
dec_8b10b[0b0110101011]=0b00010110
dec_8b10b[0b0001101011]=0b00001000
dec_8b10b[0b1001101011]=0b00011001
dec_8b10b[0b0101101011]=0b00011010
dec_8b10b[0b0011101011]=0b00011100
dec_8b10b[0b1000011011]=0b00011110
dec_8b10b[0b0100011011]=0b00011101
dec_8b10b[0b1100011011]=0b00000011
dec_8b10b[0b0010011011]=0b00011011
dec_8b10b[0b1010011011]=0b00000101
dec_8b10b[0b0110011011]=0b00000110
dec_8b10b[0b0001011011]=0b00010111
dec_8b10b[0b1001011011]=0b00001001
dec_8b10b[0b0101011011]=0b00001010
dec_8b10b[0b0011011011]=0b00001100
dec_8b10b[0b1000111011]=0b00010001
dec_8b10b[0b0100111011]=0b00010010
dec_8b10b[0b0010111011]=0b00010100
dec_8b10b[0b1100000111]=0b11111100
dec_8b10b[0b1010000111]=0b11101111
dec_8b10b[0b0110000111]=0b11100000
dec_8b10b[0b1110000111]=0b11100111
dec_8b10b[0b1001000111]=0b11110000
dec_8b10b[0b0101000111]=0b11111111
dec_8b10b[0b1101000111]=0b11101011
dec_8b10b[0b0011000111]=0b11111000
dec_8b10b[0b1011000111]=0b11101101
dec_8b10b[0b0111000111]=0b11101110
dec_8b10b[0b1000100111]=0b11100001
dec_8b10b[0b0100100111]=0b11100010
dec_8b10b[0b1100100111]=0b11110011
dec_8b10b[0b0010100111]=0b11100100
dec_8b10b[0b1010100111]=0b11110101
dec_8b10b[0b0110100111]=0b11110110
dec_8b10b[0b0001100111]=0b11101000
dec_8b10b[0b1001100111]=0b11111001
dec_8b10b[0b0101100111]=0b11111010
dec_8b10b[0b1000010111]=0b11111110
dec_8b10b[0b0100010111]=0b11111101
dec_8b10b[0b1100010111]=0b11100011
dec_8b10b[0b0010010111]=0b11111011
dec_8b10b[0b1010010111]=0b11100101
dec_8b10b[0b0110010111]=0b11100110
dec_8b10b[0b0001010111]=0b11110111
dec_8b10b[0b1001010111]=0b11101001
dec_8b10b[0b0101010111]=0b11101010
dec_8b10b[0b0011010111]=0b11101100
dec_8b10b[0b1000110111]=0b11110001
dec_8b10b[0b0100110111]=0b11110010
dec_8b10b[0b0010110111]=0b11110100


dec_8b10bK[0b1101001000]=False
dec_8b10bK[0b1011001000]=False
dec_8b10bK[0b0111001000]=False
dec_8b10bK[0b1100101000]=True
dec_8b10bK[0b1010101000]=True
dec_8b10bK[0b0110101000]=True
dec_8b10bK[0b1110101000]=True
dec_8b10bK[0b1001101000]=True
dec_8b10bK[0b0101101000]=True
dec_8b10bK[0b1101101000]=True
dec_8b10bK[0b1011101000]=True
dec_8b10bK[0b0111101000]=True
dec_8b10bK[0b1100011000]=True
dec_8b10bK[0b1010011000]=True
dec_8b10bK[0b0110011000]=True
dec_8b10bK[0b1110011000]=True
dec_8b10bK[0b1001011000]=True
dec_8b10bK[0b0101011000]=True
dec_8b10bK[0b1101011000]=True
dec_8b10bK[0b0011011000]=True
dec_8b10bK[0b1011011000]=True
dec_8b10bK[0b0111011000]=True
dec_8b10bK[0b1000111000]=True
dec_8b10bK[0b0100111000]=True
dec_8b10bK[0b1100111000]=True
dec_8b10bK[0b0010111000]=True
dec_8b10bK[0b1010111000]=True
dec_8b10bK[0b0110111000]=True
dec_8b10bK[0b0001111000]=True
dec_8b10bK[0b1001111000]=True
dec_8b10bK[0b0101111000]=True
dec_8b10bK[0b0011111000]=True
dec_8b10bK[0b1101000100]=False
dec_8b10bK[0b1011000100]=False
dec_8b10bK[0b0111000100]=False
dec_8b10bK[0b1100100100]=False
dec_8b10bK[0b1010100100]=False
dec_8b10bK[0b0110100100]=False
dec_8b10bK[0b1110100100]=False
dec_8b10bK[0b1001100100]=False
dec_8b10bK[0b0101100100]=False
dec_8b10bK[0b1101100100]=False
dec_8b10bK[0b0011100100]=False
dec_8b10bK[0b1011100100]=False
dec_8b10bK[0b0111100100]=False
dec_8b10bK[0b1100010100]=False
dec_8b10bK[0b1010010100]=False
dec_8b10bK[0b0110010100]=False
dec_8b10bK[0b1110010100]=False
dec_8b10bK[0b1001010100]=False
dec_8b10bK[0b0101010100]=False
dec_8b10bK[0b1101010100]=False
dec_8b10bK[0b0011010100]=False
dec_8b10bK[0b1011010100]=False
dec_8b10bK[0b0111010100]=False
dec_8b10bK[0b1000110100]=False
dec_8b10bK[0b0100110100]=False
dec_8b10bK[0b1100110100]=False
dec_8b10bK[0b0010110100]=False
dec_8b10bK[0b1010110100]=False
dec_8b10bK[0b0110110100]=False
dec_8b10bK[0b0001110100]=False
dec_8b10bK[0b1001110100]=False
dec_8b10bK[0b0101110100]=False
dec_8b10bK[0b0011110100]=True
dec_8b10bK[0b1100001100]=True
dec_8b10bK[0b1010001100]=False
dec_8b10bK[0b0110001100]=False
dec_8b10bK[0b1110001100]=False
dec_8b10bK[0b1001001100]=False
dec_8b10bK[0b0101001100]=False
dec_8b10bK[0b1101001100]=False
dec_8b10bK[0b0011001100]=False
dec_8b10bK[0b1011001100]=False
dec_8b10bK[0b0111001100]=False
dec_8b10bK[0b1000101100]=False
dec_8b10bK[0b0100101100]=False
dec_8b10bK[0b1100101100]=False
dec_8b10bK[0b0010101100]=False
dec_8b10bK[0b1010101100]=False
dec_8b10bK[0b0110101100]=False
dec_8b10bK[0b0001101100]=False
dec_8b10bK[0b1001101100]=False
dec_8b10bK[0b0101101100]=False
dec_8b10bK[0b0011101100]=False
dec_8b10bK[0b1000011100]=False
dec_8b10bK[0b0100011100]=False
dec_8b10bK[0b1100011100]=False
dec_8b10bK[0b0010011100]=False
dec_8b10bK[0b1010011100]=False
dec_8b10bK[0b0110011100]=False
dec_8b10bK[0b0001011100]=False
dec_8b10bK[0b1001011100]=False
dec_8b10bK[0b0101011100]=False
dec_8b10bK[0b0011011100]=False
dec_8b10bK[0b1000111100]=False
dec_8b10bK[0b0100111100]=False
dec_8b10bK[0b0010111100]=False
dec_8b10bK[0b1101000010]=False
dec_8b10bK[0b1011000010]=False
dec_8b10bK[0b0111000010]=False
dec_8b10bK[0b1100100010]=False
dec_8b10bK[0b1010100010]=False
dec_8b10bK[0b0110100010]=False
dec_8b10bK[0b1110100010]=False
dec_8b10bK[0b1001100010]=False
dec_8b10bK[0b0101100010]=False
dec_8b10bK[0b1101100010]=False
dec_8b10bK[0b0011100010]=False
dec_8b10bK[0b1011100010]=False
dec_8b10bK[0b0111100010]=False
dec_8b10bK[0b1100010010]=False
dec_8b10bK[0b1010010010]=False
dec_8b10bK[0b0110010010]=False
dec_8b10bK[0b1110010010]=False
dec_8b10bK[0b1001010010]=False
dec_8b10bK[0b0101010010]=False
dec_8b10bK[0b1101010010]=False
dec_8b10bK[0b0011010010]=False
dec_8b10bK[0b1011010010]=False
dec_8b10bK[0b0111010010]=False
dec_8b10bK[0b1000110010]=False
dec_8b10bK[0b0100110010]=False
dec_8b10bK[0b1100110010]=False
dec_8b10bK[0b0010110010]=False
dec_8b10bK[0b1010110010]=False
dec_8b10bK[0b0110110010]=False
dec_8b10bK[0b0001110010]=False
dec_8b10bK[0b1001110010]=False
dec_8b10bK[0b0101110010]=False
dec_8b10bK[0b0011110010]=True
dec_8b10bK[0b1100001010]=True
dec_8b10bK[0b1010001010]=False
dec_8b10bK[0b0110001010]=False
dec_8b10bK[0b1110001010]=False
dec_8b10bK[0b1001001010]=False
dec_8b10bK[0b0101001010]=False
dec_8b10bK[0b1101001010]=False
dec_8b10bK[0b0011001010]=False
dec_8b10bK[0b1011001010]=False
dec_8b10bK[0b0111001010]=False
dec_8b10bK[0b1000101010]=False
dec_8b10bK[0b0100101010]=False
dec_8b10bK[0b1100101010]=False
dec_8b10bK[0b0010101010]=False
dec_8b10bK[0b1010101010]=False
dec_8b10bK[0b0110101010]=False
dec_8b10bK[0b1110101010]=False
dec_8b10bK[0b0001101010]=False
dec_8b10bK[0b1001101010]=False
dec_8b10bK[0b0101101010]=False
dec_8b10bK[0b1101101010]=False
dec_8b10bK[0b0011101010]=False
dec_8b10bK[0b1011101010]=False
dec_8b10bK[0b0111101010]=False
dec_8b10bK[0b1000011010]=False
dec_8b10bK[0b0100011010]=False
dec_8b10bK[0b1100011010]=False
dec_8b10bK[0b0010011010]=False
dec_8b10bK[0b1010011010]=False
dec_8b10bK[0b0110011010]=False
dec_8b10bK[0b1110011010]=False
dec_8b10bK[0b0001011010]=False
dec_8b10bK[0b1001011010]=False
dec_8b10bK[0b0101011010]=False
dec_8b10bK[0b1101011010]=False
dec_8b10bK[0b0011011010]=False
dec_8b10bK[0b1011011010]=False
dec_8b10bK[0b0111011010]=False
dec_8b10bK[0b1000111010]=False
dec_8b10bK[0b0100111010]=False
dec_8b10bK[0b1100111010]=False
dec_8b10bK[0b0010111010]=False
dec_8b10bK[0b1010111010]=False
dec_8b10bK[0b0110111010]=False
dec_8b10bK[0b0001111010]=False
dec_8b10bK[0b1001111010]=False
dec_8b10bK[0b0101111010]=False
dec_8b10bK[0b0011111010]=True
dec_8b10bK[0b1100000110]=True
dec_8b10bK[0b1010000110]=False
dec_8b10bK[0b0110000110]=False
dec_8b10bK[0b1110000110]=False
dec_8b10bK[0b1001000110]=False
dec_8b10bK[0b0101000110]=False
dec_8b10bK[0b1101000110]=False
dec_8b10bK[0b0011000110]=False
dec_8b10bK[0b1011000110]=False
dec_8b10bK[0b0111000110]=False
dec_8b10bK[0b1000100110]=False
dec_8b10bK[0b0100100110]=False
dec_8b10bK[0b1100100110]=False
dec_8b10bK[0b0010100110]=False
dec_8b10bK[0b1010100110]=False
dec_8b10bK[0b0110100110]=False
dec_8b10bK[0b1110100110]=False
dec_8b10bK[0b0001100110]=False
dec_8b10bK[0b1001100110]=False
dec_8b10bK[0b0101100110]=False
dec_8b10bK[0b1101100110]=False
dec_8b10bK[0b0011100110]=False
dec_8b10bK[0b1011100110]=False
dec_8b10bK[0b0111100110]=False
dec_8b10bK[0b1000010110]=False
dec_8b10bK[0b0100010110]=False
dec_8b10bK[0b1100010110]=False
dec_8b10bK[0b0010010110]=False
dec_8b10bK[0b1010010110]=False
dec_8b10bK[0b0110010110]=False
dec_8b10bK[0b1110010110]=False
dec_8b10bK[0b0001010110]=False
dec_8b10bK[0b1001010110]=False
dec_8b10bK[0b0101010110]=False
dec_8b10bK[0b1101010110]=False
dec_8b10bK[0b0011010110]=False
dec_8b10bK[0b1011010110]=False
dec_8b10bK[0b0111010110]=False
dec_8b10bK[0b1000110110]=False
dec_8b10bK[0b0100110110]=False
dec_8b10bK[0b1100110110]=False
dec_8b10bK[0b0010110110]=False
dec_8b10bK[0b1010110110]=False
dec_8b10bK[0b0110110110]=False
dec_8b10bK[0b0001110110]=False
dec_8b10bK[0b1001110110]=False
dec_8b10bK[0b0101110110]=False
dec_8b10bK[0b0011110110]=True
dec_8b10bK[0b1010001110]=False
dec_8b10bK[0b0110001110]=False
dec_8b10bK[0b1110001110]=False
dec_8b10bK[0b1001001110]=False
dec_8b10bK[0b0101001110]=False
dec_8b10bK[0b1101001110]=False
dec_8b10bK[0b0011001110]=False
dec_8b10bK[0b1011001110]=False
dec_8b10bK[0b0111001110]=False
dec_8b10bK[0b1000101110]=False
dec_8b10bK[0b0100101110]=False
dec_8b10bK[0b1100101110]=False
dec_8b10bK[0b0010101110]=False
dec_8b10bK[0b1010101110]=False
dec_8b10bK[0b0110101110]=False
dec_8b10bK[0b0001101110]=False
dec_8b10bK[0b1001101110]=False
dec_8b10bK[0b0101101110]=False
dec_8b10bK[0b0011101110]=False
dec_8b10bK[0b1000011110]=False
dec_8b10bK[0b0100011110]=False
dec_8b10bK[0b1100011110]=False
dec_8b10bK[0b0010011110]=False
dec_8b10bK[0b1010011110]=False
dec_8b10bK[0b0110011110]=False
dec_8b10bK[0b0001011110]=False
dec_8b10bK[0b1001011110]=False
dec_8b10bK[0b0101011110]=False
dec_8b10bK[0b0011011110]=False
dec_8b10bK[0b1100100001]=False
dec_8b10bK[0b1010100001]=False
dec_8b10bK[0b0110100001]=False
dec_8b10bK[0b1110100001]=False
dec_8b10bK[0b1001100001]=False
dec_8b10bK[0b0101100001]=False
dec_8b10bK[0b1101100001]=False
dec_8b10bK[0b0011100001]=False
dec_8b10bK[0b1011100001]=False
dec_8b10bK[0b0111100001]=False
dec_8b10bK[0b1100010001]=False
dec_8b10bK[0b1010010001]=False
dec_8b10bK[0b0110010001]=False
dec_8b10bK[0b1110010001]=False
dec_8b10bK[0b1001010001]=False
dec_8b10bK[0b0101010001]=False
dec_8b10bK[0b1101010001]=False
dec_8b10bK[0b0011010001]=False
dec_8b10bK[0b1011010001]=False
dec_8b10bK[0b0111010001]=False
dec_8b10bK[0b1000110001]=False
dec_8b10bK[0b0100110001]=False
dec_8b10bK[0b1100110001]=False
dec_8b10bK[0b0010110001]=False
dec_8b10bK[0b1010110001]=False
dec_8b10bK[0b0110110001]=False
dec_8b10bK[0b0001110001]=False
dec_8b10bK[0b1001110001]=False
dec_8b10bK[0b0101110001]=False
dec_8b10bK[0b1100001001]=True
dec_8b10bK[0b1010001001]=False
dec_8b10bK[0b0110001001]=False
dec_8b10bK[0b1110001001]=False
dec_8b10bK[0b1001001001]=False
dec_8b10bK[0b0101001001]=False
dec_8b10bK[0b1101001001]=False
dec_8b10bK[0b0011001001]=False
dec_8b10bK[0b1011001001]=False
dec_8b10bK[0b0111001001]=False
dec_8b10bK[0b1000101001]=False
dec_8b10bK[0b0100101001]=False
dec_8b10bK[0b1100101001]=False
dec_8b10bK[0b0010101001]=False
dec_8b10bK[0b1010101001]=False
dec_8b10bK[0b0110101001]=False
dec_8b10bK[0b1110101001]=False
dec_8b10bK[0b0001101001]=False
dec_8b10bK[0b1001101001]=False
dec_8b10bK[0b0101101001]=False
dec_8b10bK[0b1101101001]=False
dec_8b10bK[0b0011101001]=False
dec_8b10bK[0b1011101001]=False
dec_8b10bK[0b0111101001]=False
dec_8b10bK[0b1000011001]=False
dec_8b10bK[0b0100011001]=False
dec_8b10bK[0b1100011001]=False
dec_8b10bK[0b0010011001]=False
dec_8b10bK[0b1010011001]=False
dec_8b10bK[0b0110011001]=False
dec_8b10bK[0b1110011001]=False
dec_8b10bK[0b0001011001]=False
dec_8b10bK[0b1001011001]=False
dec_8b10bK[0b0101011001]=False
dec_8b10bK[0b1101011001]=False
dec_8b10bK[0b0011011001]=False
dec_8b10bK[0b1011011001]=False
dec_8b10bK[0b0111011001]=False
dec_8b10bK[0b1000111001]=False
dec_8b10bK[0b0100111001]=False
dec_8b10bK[0b1100111001]=False
dec_8b10bK[0b0010111001]=False
dec_8b10bK[0b1010111001]=False
dec_8b10bK[0b0110111001]=False
dec_8b10bK[0b0001111001]=False
dec_8b10bK[0b1001111001]=False
dec_8b10bK[0b0101111001]=False
dec_8b10bK[0b0011111001]=True
dec_8b10bK[0b1100000101]=True
dec_8b10bK[0b1010000101]=False
dec_8b10bK[0b0110000101]=False
dec_8b10bK[0b1110000101]=False
dec_8b10bK[0b1001000101]=False
dec_8b10bK[0b0101000101]=False
dec_8b10bK[0b1101000101]=False
dec_8b10bK[0b0011000101]=False
dec_8b10bK[0b1011000101]=False
dec_8b10bK[0b0111000101]=False
dec_8b10bK[0b1000100101]=False
dec_8b10bK[0b0100100101]=False
dec_8b10bK[0b1100100101]=False
dec_8b10bK[0b0010100101]=False
dec_8b10bK[0b1010100101]=False
dec_8b10bK[0b0110100101]=False
dec_8b10bK[0b1110100101]=False
dec_8b10bK[0b0001100101]=False
dec_8b10bK[0b1001100101]=False
dec_8b10bK[0b0101100101]=False
dec_8b10bK[0b1101100101]=False
dec_8b10bK[0b0011100101]=False
dec_8b10bK[0b1011100101]=False
dec_8b10bK[0b0111100101]=False
dec_8b10bK[0b1000010101]=False
dec_8b10bK[0b0100010101]=False
dec_8b10bK[0b1100010101]=False
dec_8b10bK[0b0010010101]=False
dec_8b10bK[0b1010010101]=False
dec_8b10bK[0b0110010101]=False
dec_8b10bK[0b1110010101]=False
dec_8b10bK[0b0001010101]=False
dec_8b10bK[0b1001010101]=False
dec_8b10bK[0b0101010101]=False
dec_8b10bK[0b1101010101]=False
dec_8b10bK[0b0011010101]=False
dec_8b10bK[0b1011010101]=False
dec_8b10bK[0b0111010101]=False
dec_8b10bK[0b1000110101]=False
dec_8b10bK[0b0100110101]=False
dec_8b10bK[0b1100110101]=False
dec_8b10bK[0b0010110101]=False
dec_8b10bK[0b1010110101]=False
dec_8b10bK[0b0110110101]=False
dec_8b10bK[0b0001110101]=False
dec_8b10bK[0b1001110101]=False
dec_8b10bK[0b0101110101]=False
dec_8b10bK[0b0011110101]=True
dec_8b10bK[0b1100001101]=True
dec_8b10bK[0b1010001101]=False
dec_8b10bK[0b0110001101]=False
dec_8b10bK[0b1110001101]=False
dec_8b10bK[0b1001001101]=False
dec_8b10bK[0b0101001101]=False
dec_8b10bK[0b1101001101]=False
dec_8b10bK[0b0011001101]=False
dec_8b10bK[0b1011001101]=False
dec_8b10bK[0b0111001101]=False
dec_8b10bK[0b1000101101]=False
dec_8b10bK[0b0100101101]=False
dec_8b10bK[0b1100101101]=False
dec_8b10bK[0b0010101101]=False
dec_8b10bK[0b1010101101]=False
dec_8b10bK[0b0110101101]=False
dec_8b10bK[0b0001101101]=False
dec_8b10bK[0b1001101101]=False
dec_8b10bK[0b0101101101]=False
dec_8b10bK[0b0011101101]=False
dec_8b10bK[0b1000011101]=False
dec_8b10bK[0b0100011101]=False
dec_8b10bK[0b1100011101]=False
dec_8b10bK[0b0010011101]=False
dec_8b10bK[0b1010011101]=False
dec_8b10bK[0b0110011101]=False
dec_8b10bK[0b0001011101]=False
dec_8b10bK[0b1001011101]=False
dec_8b10bK[0b0101011101]=False
dec_8b10bK[0b0011011101]=False
dec_8b10bK[0b1000111101]=False
dec_8b10bK[0b0100111101]=False
dec_8b10bK[0b0010111101]=False
dec_8b10bK[0b1101000011]=False
dec_8b10bK[0b1011000011]=False
dec_8b10bK[0b0111000011]=False
dec_8b10bK[0b1100100011]=False
dec_8b10bK[0b1010100011]=False
dec_8b10bK[0b0110100011]=False
dec_8b10bK[0b1110100011]=False
dec_8b10bK[0b1001100011]=False
dec_8b10bK[0b0101100011]=False
dec_8b10bK[0b1101100011]=False
dec_8b10bK[0b0011100011]=False
dec_8b10bK[0b1011100011]=False
dec_8b10bK[0b0111100011]=False
dec_8b10bK[0b1100010011]=False
dec_8b10bK[0b1010010011]=False
dec_8b10bK[0b0110010011]=False
dec_8b10bK[0b1110010011]=False
dec_8b10bK[0b1001010011]=False
dec_8b10bK[0b0101010011]=False
dec_8b10bK[0b1101010011]=False
dec_8b10bK[0b0011010011]=False
dec_8b10bK[0b1011010011]=False
dec_8b10bK[0b0111010011]=False
dec_8b10bK[0b1000110011]=False
dec_8b10bK[0b0100110011]=False
dec_8b10bK[0b1100110011]=False
dec_8b10bK[0b0010110011]=False
dec_8b10bK[0b1010110011]=False
dec_8b10bK[0b0110110011]=False
dec_8b10bK[0b0001110011]=False
dec_8b10bK[0b1001110011]=False
dec_8b10bK[0b0101110011]=False
dec_8b10bK[0b0011110011]=True
dec_8b10bK[0b1100001011]=True
dec_8b10bK[0b1010001011]=False
dec_8b10bK[0b0110001011]=False
dec_8b10bK[0b1110001011]=False
dec_8b10bK[0b1001001011]=False
dec_8b10bK[0b0101001011]=False
dec_8b10bK[0b1101001011]=False
dec_8b10bK[0b0011001011]=False
dec_8b10bK[0b1011001011]=False
dec_8b10bK[0b0111001011]=False
dec_8b10bK[0b1000101011]=False
dec_8b10bK[0b0100101011]=False
dec_8b10bK[0b1100101011]=False
dec_8b10bK[0b0010101011]=False
dec_8b10bK[0b1010101011]=False
dec_8b10bK[0b0110101011]=False
dec_8b10bK[0b0001101011]=False
dec_8b10bK[0b1001101011]=False
dec_8b10bK[0b0101101011]=False
dec_8b10bK[0b0011101011]=False
dec_8b10bK[0b1000011011]=False
dec_8b10bK[0b0100011011]=False
dec_8b10bK[0b1100011011]=False
dec_8b10bK[0b0010011011]=False
dec_8b10bK[0b1010011011]=False
dec_8b10bK[0b0110011011]=False
dec_8b10bK[0b0001011011]=False
dec_8b10bK[0b1001011011]=False
dec_8b10bK[0b0101011011]=False
dec_8b10bK[0b0011011011]=False
dec_8b10bK[0b1000111011]=False
dec_8b10bK[0b0100111011]=False
dec_8b10bK[0b0010111011]=False
dec_8b10bK[0b1100000111]=True
dec_8b10bK[0b1010000111]=True
dec_8b10bK[0b0110000111]=True
dec_8b10bK[0b1110000111]=True
dec_8b10bK[0b1001000111]=True
dec_8b10bK[0b0101000111]=True
dec_8b10bK[0b1101000111]=True
dec_8b10bK[0b0011000111]=True
dec_8b10bK[0b1011000111]=True
dec_8b10bK[0b0111000111]=True
dec_8b10bK[0b1000100111]=True
dec_8b10bK[0b0100100111]=True
dec_8b10bK[0b1100100111]=True
dec_8b10bK[0b0010100111]=True
dec_8b10bK[0b1010100111]=True
dec_8b10bK[0b0110100111]=True
dec_8b10bK[0b0001100111]=True
dec_8b10bK[0b1001100111]=True
dec_8b10bK[0b0101100111]=True
dec_8b10bK[0b1000010111]=True
dec_8b10bK[0b0100010111]=True
dec_8b10bK[0b1100010111]=True
dec_8b10bK[0b0010010111]=True
dec_8b10bK[0b1010010111]=True
dec_8b10bK[0b0110010111]=True
dec_8b10bK[0b0001010111]=True
dec_8b10bK[0b1001010111]=True
dec_8b10bK[0b0101010111]=True
dec_8b10bK[0b0011010111]=True
dec_8b10bK[0b1000110111]=False
dec_8b10bK[0b0100110111]=False
dec_8b10bK[0b0010110111]=False

def offset(cap):
    """
    Return the offset in the stream `cap` by matching up to 10 to IDLE patterns.
    """
    start=cap[:,0] # first word
    offs=np.zeros(len(cap), dtype=np.uint8)
    for offset in range(10):
        tIDLE0=((start>>(22-offset))^IDLE0)&0x3FF==0
        tIDLE1=((start>>(22-offset))^IDLE1)&0x3FF==0
        offs[tIDLE0|tIDLE1]=offset
    return offs

def align(cap):
    """
    Aligns the capture stream such that the first bit is the MSB of the encoded
    idle pattern.
    """
    offs=offset(cap)
    return bs.left_shift(cap, offs)

def decode(cap):
    """
    Decodes a bitstream `cap` from 10b to 8b.

    Returns `val`, `k` where `val` is an array of uint8 containing the decoded 
    data and `k` is an array of bool indicating control status..
    """
    nbits=len(cap[0])*32 # Assume all streams have the same length
    nbytes=nbits//10
    val=ak.Array([[]]*len(cap))
    k  =ak.Array([[]]*len(cap))
    for i in range(nbytes):
        x=bs.bits(cap,10*i,10)
        val=ak.concatenate([val,dec_8b10b [x].reshape(-1,1)],axis=1)
        k  =ak.concatenate([k  ,dec_8b10bK[x].reshape(-1,1)],axis=1)
    return val,k